"dcoex" <- 
function(sample1, sample2, startmatrix=NULL, alpha=NULL, incdata=FALSE)
{
   exproutput  <- FALSE
   tempsample1 <- sample1
   
   ## check input for expression set
   
   if ( !is.numeric(sample1) | !is.numeric(sample2) )
   {
     try(sample1<-exprs(sample1))
     try(sample2<-exprs(sample2))
     exproutput<-TRUE
   }
   
      
   ## if try failed and the matrices aren't numeric: ERROR
   else if (!is.numeric(sample1) | !is.numeric(sample2))
   {
     stop("improper usage! you have to enter two exprSet or two numeric matrices",call.=FALSE)
   }


   ## kmeans
   if (is.character(startmatrix))
   {
     if (startmatrix=="kmeans")
     {
       startmatrix<-as.matrix(dcoex.kmeans(sample1))
     }
   }
   
   ## all checked continue with dcoex.main
   
   dcoexoutput<-dcoex.main(sample1,sample2,startmatrix,alpha)


   ## analyse the results of C#-dcoex

   dout_rows<-dim(dcoexoutput)[1]-1  ## last row of dcoexoutput is the final_res which we do not use 
   dout_cols<-dim(dcoexoutput)[2]
    
   #(1)# maximal row-size for the output 
   mrows <- 0
   checktemp <- 0
   for (i in 1:dout_cols)
   { 
     checktemp <- sum(dcoexoutput[1:dout_rows,i])
   }
  
   if (checktemp > mrows)
   {
     mrows <- checktemp
   }

   #(2)# colums of startmatrix
   scols<-1
  
   if (!is.null(startmatrix))
   {
     foo<-dim(startmatrix)[2]
     
     if(!is.null(foo)) 
     {
       scols <- dim(startmatrix)[2]
     }
     else
     {
       scols <- startmatrix
     }
   }
   
   
   ## with (1) and (2) we create the outputmatrix 
      
   new_list<-matrix(data=0, nrow = mrows, ncol=scols)

   ## fill the outputmatrix...
   
   for (i in 1:dout_cols)
   {
     if (sum(dcoexoutput[1:dout_rows,i]) > 0)
     {
       one_list<-which(as.logical(dcoexoutput[(1:dout_rows),i]))
       new_list[1:length(one_list),i]<-one_list
     }
   }   

   ## if an expressionSet was given, return a matrix of the gennames
   
   if (exproutput)
   {
     gennames<-new_list  
       
     for (i in 1:scols)
     {
            
       if (sum(new_list[,i])!=0)
       for (j in 1:mrows)
       if (new_list[j,i]>0)
       { 
         gennames[j,i]<-(geneNames(tempsample1[new_list[j,i],1]))
       }
     }
     new_list<-gennames
     out<-new_list
   }
   
   out<-new_list
   rm(new_list)
   
   # if the samples are to big we should not save them.
   if ((sum(prod(dim(sample1)),prod(dim(sample2))) > 1000000) || incdata )
   {
     paste("sum of values are > 1.000.000 so the output does not include the two groups")
     dcoex.all<-list(dcoex.genes = out, starfile = startmatrix, residual = dcoexoutput[dout_rows+1,])
   }
   
   else  # we save only the size of the samples
   {
     dcoex.all<-list(nsample1.cols = dim(sample1)[2], nsample2.cols = dim(sample2)[2], dcoex.genes = out, startfile = startmatrix, residual = dcoexoutput[dout_rows+1,])
   }
   return(dcoex.all)      
}
