##---	given a mean row mean and a mean column mean, generate an expression 
##	matrix according to the additive model. the signal to noise ratio
##	is given by ratio

"dcoex.gendat" <-
function(ng=0, np=0, mean=0, sd=1,ratio=10){

   a = rnorm(ng, sd=sd)
   b = rnorm(np, sd=sd)
   noise = matrix(rnorm((ng*np), mean= mean, sd=sd/ratio), ncol=np)
   model= dcoex.genmodel(a,b)
   res = model+noise
   return(res)
}

##---	given the row and the column effects, generate data according
##	to the additive model. excluding noise.

"dcoex.genmodel" <-
function(a,b) {

   nr = length(a)
   nc = length(b)
   model = matrix(0, ncol=nc, nrow=nr)
   model = model + a
   model = t(t(model) + b)
   return(model)
}

