"dcoex.main" <-
function(sample1,sample2,startmatrix=NULL,alpha=NULL)
{  
   
   # check if rows of the input matrices are equal
   rows <- dim(sample1)[1]

   if (rows != dim(sample2)[1])
   {
      stop("fail... rows of exprs_matrices do not match",call.=FALSE);
   }

   # initialize
   exists_startmatrix <- 0; 
   start_cols=1;
   col_sample1 <- dim(sample1)[2];
   col_sample2 <- dim(sample2)[2];
   
   # check alpha; default=0.5

   if (is.null(alpha))
   {
     paste("tuning parameter alpha is 0.5")  
     alpha<-0.5
   }
   
   else if ((alpha >1) | (alpha < 0))
   {
     paste("tuning parameter alpha only in [0,1], therefor alpha<-0.5")
     alpha<-0.5
   }
   
   # existing and zero-check startmatrix
   if ( !is.null(startmatrix))  # if startmatrix exists
   {
      if (sum(startmatrix) !=0)         # and elements are not zero
      {
         check<-dim(startmatrix)[1];

         if (is.matrix(startmatrix) && rows == check) # row-length of sample1 must be equal to startmatrix row-length
         {
            start_cols <- dim(startmatrix)[2];
            exists_startmatrix <- 1;
         }
         
         else if (is.null(check))
         {
            exists_startmatrix <- 2
         }
      }
      else # if elements are zero -> STOP! or length of rows mismatch
      {
         stop ("\n sorry, incorrect startmatrix.\n\n",call.=FALSE);
      }
   }

   # call C#-dcoex
   as.matrix(
   .Call("dcoex",
   as.numeric(sample1),
   as.numeric(sample2),
   as.integer(rows),
   as.integer(col_sample1),
   as.integer(col_sample2),
   as.integer(exists_startmatrix),
   as.numeric(startmatrix),
   as.integer(start_cols),
   as.numeric(alpha),
   PACKAGE="dcoex"))
}
