"dcoex.plot" <-
function(sample1,sample2,inds)
{
   par(cex=2)
   
   D1 <- sample1[inds,]
   D2 <- sample2[inds,]
   sds1 <- apply(D1,1,sd)
   sds2 <- apply(D2,1,sd)

   par(mfrow=c(2,1),xaxt="n", yaxt="n")

   ##--- plot 1
   subplot.bc3(D1,D2,rep(TRUE,length(inds)))

   ##--- seperating line
   d1 = dim(sample1)[2]
   d2 = dim(sample2)[2]
   x   = d1+.5
   lines(c(x,x),c(-20,20),lwd=3)

   ##--- plot 2
   subplot.bc2(D1/sds1,D2/sds2,rep(TRUE,length(inds)))

   ##--- seperating line
   d1 = dim(sample1)[2]
   d2 = dim(sample2)[2]
   x   = d1+.5
   lines(c(x,x),c(-20,20),lwd=3)
}

"subplot.bc2" <-
function(mat1, mat2, ind)
{
  m1  = mat1[ind,] - rowMeans(mat1[ind,])
  m2  = mat2[ind,] - rowMeans(mat2[ind,])
  m   = cbind(m1,m2)
  min = 1.1*min(m)
  max = 1.1*max(m)
  par(mai=c(0.5,.5,0.25,.5))
  plot(m[1,], ylim=c(min,max), type="l", xlab="", ylab="")
  for(i in 1:dim(m)[1]){
    lines(m[i,])}
  #lines(c(colMeans(m1),colMeans(m2)),col=2, lwd=2)
}

"subplot.bc3" <-
function(mat1, mat2, ind)
{
  m1  = mat1[ind,]
  m2  = mat2[ind,]
  m   = cbind(m1,m2)
  min = 1.1*min(m)
  max = 1.1*max(m)
  par(mai=c(0.25,.5,0.5,.5))
  plot(m[1,], ylim=c(min,max),type="l", main="", xlab="", ylab="")
  for(i in 1:dim(m)[1])
  {
     lines(m[i,])
  }
}
