\name{dcoex.main}
\alias{dcoex.main}
\title{ dcoex (differentially coexpressed genes) }

\description{ 	Interface used by \code{dcoex}. Lacks some parameters.
  
}

\usage{
    dcoex.main(sample1, sample2, startmatrix = NULL, alpha = NULL)
}

\arguments{
  \item{sample1}{	matrix or exprSet, containing of gene expression values of the 'control' group.
                        If matrix, rows are genes and columns are samples.
                }
  \item{sample2}{ 	matrix or exprSet, containing of gene expression values of the 'disease' group.
                        If matrix, rows are genes and columns are samples.
                }
  \item{startmatrix}{	if a (binary) matrix is passed, it is  coding for starting points of the search
                        algorithm. It has to have the same number of rows as 'sample1' and 'sample2'. Each
                        column represents a starting point. A one codes for a gene included in the
                        starting group, a zero for an excluded gene. For each column a search is performed.
                        If it is  an (integer) number, so many random starting points are generated and
                        for each one a search is performed. If \code{startmatrix}="kmeans" dcoex.kmeans
                        generates a startmatrix by using kmeans-clustering.
                    }
  \item{alpha}{		numeric, tuning parameter in [0,1]. Larger values of alpha yield smaller groups
                        of genes and vice versa.
              }		    
}

\value{
			dcoex returns a zero-one-vector or matrix (depending on the value of \code{startmatrix})
			of differentially coexpressed genes. The last row / entry corresponds to the residual
			of the group of genes returned.
 }

\references{ Kostka D, Spang R (2004): Finding disease specific alterations in the coexpression of genes  }

\author{ Dominic Fabian }

\seealso{ \code{dcoex}:         all in one function
          \code{dcoex.draw}:    dcoex plot function
          \code{dcoex.draw.ps}: plot function which attempts to make an postscript}
\examples{

## generate somedata
cols=50
rows=500
c=cols*rows
sample1<-matrix(rnorm(c), nrow=rows,ncol=cols)
sample2<-matrix(rnorm(c), nrow=rows,ncol=cols)

## start dcoex with the generated data

testdata<-dcoex.main(sample1,sample2)

## start dcoex using a startmatrix
## (not executable without declaring "startmatrix")

# testdata<-dcoex.main(sample1,sample2,startmatrix)

## start dcoex using the tuning parameter alpha
## (not executable without declaring "alpha")

# testdata<-dcoex.main(sample1,sample2,NULL,alpha) 
      
}
\keyword{ interface }% at least one, from doc/KEYWORDS
