
/*  COMMENT

(*) row-bases stored in global var
(*) both expression matrices stored in global var
(*) couple of global scratch vectors to save alloc/free 's */

/* the other headers */

#include "gsl_func.h"


typedef struct pattern
{
  int        vol;	       	/* volume                            */
  double     mean1;	       	/* overall pattern mean in grp1      */
  double     mean2;	       	/* overall pattern mean in grp2      */
  double     res;	       	/* overall pattern residual          */
  double     res1;
  double     res2;
  int        nr;	       	/* number of rows in pattern           */
  gsl_vector *rind;		/* ptr to vector of row indices        */
  gsl_vector *cbase1;		/* vector of column bases of grp 1     */
  gsl_vector *cbase2;		/* vector of column bases of grp 2     */
}
Pattern;

typedef struct action
{
  int     ind;			/* row  or column index                */
  int     arflag;		/* remove = 0, add = 1                 */
  double  gain;			/* gain  associated with action        */
  double  del1;			/* Delta1                              */
  double  B1;
  double  B2;
  Pattern *ptrn;	        /* pointer to associated pattern       */
}
Action;


/* the functions */
int     rand_bin_gen(double);
int 	matrix_scale(gsl_matrix *);
int 	fpattern(gsl_matrix *, double *, int *, double, gsl_vector *,int,int,double);
void 	moi_outer (const gsl_vector *, const gsl_vector *, gsl_matrix *);
void 	vec_expand (const gsl_vector *, const gsl_vector *, gsl_matrix *);
double 	matrix_sum (const gsl_matrix *);
void   	matrix_zero (gsl_matrix *, const gsl_vector *);
double 	moi_bc_mean (const gsl_matrix *, gsl_vector *, gsl_vector *);
double 	moi_bc_res (Pattern *);
double 	ptrn_res (Pattern *);
Pattern *moi_bc_alloc (int nr, int nc);
int 	moi_bc_free (Pattern *);
int 	moi_bc_initind (Pattern *, double, double);
int 	moi_matrix_print (gsl_matrix *);
int 	moi_bc_print (Pattern *);
double 	moi_ac_gain (const gsl_matrix *, const Pattern *, const Action *,
		    const double);
double 	moi_ac_gain2 (const gsl_matrix *, const Pattern *, const Action *,
		     const double);
int 	moi_ac_val (const gsl_matrix *, Action *, const Pattern *, int, int,
		double);
void	ac_sort (Action *, int);
int 	ac_comp (const void *, const void *);
void 	ac_swap (Action *, Action *);
int 	ac_rwo (Action *, int, int);
int 	moi_ac_perform (Action *, gsl_matrix *);
Pattern *ptrn_alloc (int);
int	ptrn_rind (Pattern *, int, double, int, gsl_matrix *, int, double);
void 	ptrn_free (Pattern *, int);
int 	ac_val (Action *, Pattern *, int,double);
double 	ac_gain (Pattern *,  Action *,double);
double 	moi_ac_gain_tg (Pattern *, const Action *);
int 	moi_ac_perform_tg (const Action *);
int 	ac_count (const Action *, int);
int 	ptrn_val (Pattern *);
int 	matrix_perm (gsl_matrix *, gsl_matrix *);
int 	ac_perf (const Action *, int);
int 	test_outer ();
int 	test_bc_val ();
int 	test_ac_val ();
int 	test_ac_swap ();


